#!/bin/sh
### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
#

#
# Plesk script
#


### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
# Migration manager tables will be managed by plesk

### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
set_apache_params()
{
	apache_user="apache"
	apache_UID=80
	apache_group="apache"
	apache_GID=80

	user_apxs="/usr/sbin/apxs"

	set_apache_params_linux

	apache_service="$apache_service_name"

	apache_httpd_conf="$HTTPD_CONF_D/httpd.conf"
	apache_httpd_conf2="$HTTPD_CONF_D/httpd2.conf"
	apache_httpd_conf_in="$HTTPD_CONF_D/httpd.conf.in"

	apache_httpd_include="$HTTPD_INCLUDE_D/zz010_psa_httpd.conf"

	APACHE_CERT="$HTTPD_CONF_D/httpd.pem"
	APACHE_ROOT="/usr"

	min_suexec_UID=10000
	max_suexec_UID=16000
	min_suexec_GID=$min_suexec_UID
	max_suexec_GID=$max_suexec_UID

	suexec_storage=/usr/lib64/plesk-9.0/suexec
	suexec=/usr/sbin/suexec
	suexec_dir=/usr/sbin
	suexec_file=suexec

	rpm_httpd_bin=/usr/sbin/httpd
}

set_apache_params_linux()
{
	apache_pid_file="$APACHE_ROOT/logs/httpd.pid"
	apache_lock_file="$APACHE_ROOT/logs/httpd.lock"
	product_lock_file="$HTTPD_CONF_D/cnf.lock"
	apache_service_name="httpd"

	apache_modules_d="/usr/lib64/httpd/modules"
}

module_exists()
{
	local dir
	[ -n "$1" ] || return 1
	test -n "$2" && test -e "${apache_modules_d}/$2" && return
	test -e "${apache_modules_d}/mod_$1.so" && return
	if [ -n "${additional_apache_modules_d}" ]; then
		for dir in $additional_apache_modules_d; do 
			if [ -f "${dir}/mod_$1.so"  ] ; then return ; fi
			if [ -n "$2" -a -f "${dir}/$2" ] ; then return ; fi
		done
	fi
	return 1
}

# Run before it
#        read_conf
#        # set_common_params
#        set_apache_params
add_apache_module()
{
	local module_name="$1"
	local module_soname="$2" # optional
	local config="$3" # optional

	if ! module_exists $module_name "$module_soname"; then
		# TODO : fix message error
		p_echo "Shared object mod_${module_name}.so not found in ${apache_modules_d}...skipped."
		return
	fi

# On redhat/centos some modules has own configs: perl, python
		if [ -n "$config" ] ; then
			:
		elif [ -e "$HTTPD_INCLUDE_D/$module_name.conf" ]; then
			config="$HTTPD_INCLUDE_D/$module_name.conf"
		else
			config="${apache_httpd_conf}"
		fi
		
		[ -n "$module_soname" ] || module_soname="mod_$module_name.so"
		
		cat $config | 			perl -e '
				@lines = <STDIN>;
				$found = 0;
				$lastline = 0;
				for ($i=0; $i<=$#lines; $i++)
				{
					if ( @lines[$i] =~ /^\s*?#\s*?LoadModule.*@ARGV[0]_module.*@ARGV[2]/ )
					{
						if ( $found > 0 )
						{
							@lines[$i] =~ s/^(.*)$/####This line was duplicated: $1/;
						}else{
							@lines[$i] =~ s/^\s*?#\s*?L/L/;
							$found++;
						}
					}
					elsif ( @lines[$i] =~ /^\s*?(LoadModule.*@ARGV[0]_module.*@ARGV[2])/ )
					{
						if ( $found > 0 )
						{
							@lines[$i] =~ s/^(.*)$/####This line was duplicated: $1/;
						}else{
							$found++;
						}
					}
					elsif ( @lines[$i] =~ /^[^#\s]*?<If/ )
					{
						$deep++;
					}
					elsif ( @lines[$i] =~ /^[^#\s]*?<\/If/ )
					{
						$deep--;
					}
					if ( @lines[$i] =~ /LoadModule.*_module.*so/  && $deep <= 0 )
					{
						$lastline = $i;
					}
				}
				if ( $found == 0 && $lastline > 0 )
				{
					print @lines[0..$lastline];
					print "LoadModule @ARGV[0]_module @ARGV[1]/@ARGV[2]\n";
					print @lines[$lastline+1..$#lines];
				}else{
					print @lines;
				}
			' "${module_name}" "${apache_modules_d}" "$module_soname" 		> $config.new
		mv $config.new $config
}

# Run before it
#        read_conf
#        # set_common_params
#        set_apache_params
remove_apache_module()
{
	local module_name="$1"
	local module_soname="$2" # optional
	local config="$3" # optional

# Got config to work
		if [ -n "$config" ]; then
			:
		elif [ -e "$HTTPD_INCLUDE_D/$module_name.conf" ]; then
			config="$HTTPD_INCLUDE_D/$module_name.conf"
		else
			config="${apache_httpd_conf}"
		fi

# Is shared library name specified
		[ -n "$module_soname" ] || module_soname="mod_$module_name.so"

		cat $config | 			perl -e '
				@lines = <STDIN>;
				$found = 0;
				$foundcomment = 0;
				$lastline = 0;
				$r1 = "^[^#\s]*?(LoadModule.*@ARGV[0]_module.*@ARGV[1])";
				$r2 = "^\s*?#\s*?LoadModule.*@ARGV[0]_module.*@ARGV[1]";
				for ($i=0; $i<=$#lines; $i++)
				{
					if ( @lines[$i] =~ /$r1/ )
					{
						if ( $found > 0 || $foundcomment > 0 )
						{
							@lines[$i] =~ s/^(.*)$/####This line was duplicated: $1/;
						}else{
							@lines[$i] =~ s/^(.*)$/#$1/;
							$found++;
						}
					}
					elsif ( @lines[$i] =~ /$r2/ )
					{
						if ( $foundcomment > 0 || $found > 0 )
						{
							@lines[$i] =~ s/^(.*)$/####This line was duplicated: $1/;
						}else{
							$foundcomment++;
						}
					}
				}
				print @lines;
			' "$module_name" "$module_soname" 		> "$config.new"
		mv "$config.new" "$config"
}
### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
# vim:ft=sh
# Usage:  pleskrc <service> <action>
pleskrc()
{
	[ 2 -le $# ] || die "Not enough arguments"

	local service_name=$1
	local action=$2
	local ret=0
	local inten
	local service_script=""
	shift
	shift

	# Now check redefined functions
	if test "$machine" = "linux" && is_function "${service_name}_${action}_${machine}_${linux_distr}"; then
		"${service_name}_${action}_${machine}_${linux_distr}" $@
		return $?
	elif is_function "${service_name}_${action}_${machine}"; then
		"${service_name}_${action}_${machine}" $@
		return $?
	elif is_function "${service_name}_${action}"; then
		"${service_name}_${action}" $@
		return $?
	fi

	# Not redefined - call default action
	eval "service=\$${service_name}_service"
	[ -n "$service" ] || die "$action $service_name service (Empty service name for '$service_name')"

	inten="$action service $service"
	[ "$action" = "status" -o "$action" = "exists" ] || echo_try "$inten"

	service_ctl $action $service $service_name

	ret="$?"
	if [ "$action" != "status" -a "${action}" != "exists" ]; then
		[ "$ret" -eq 0 ] && suc || warn $inten
	fi

	return $ret
}

# NOTE:
# 	Function service_ctl in both variations are just helper for pleskrc().
# 	Do not call it directly, use pleskrc()!!!
service_ctl()
{
	local action=$1
	local service=$2
	local service_name=$3

	local action_cmd=
	local service_script=

	if [ -x "$SYSTEM_RC_D/$service" ]; then
		service_script="$SYSTEM_RC_D/$service"
	elif [ ! -z "${PRODUCT_RC_D}" -a -x "$PRODUCT_RC_D/$service" ]; then
		service_script="$PRODUCT_RC_D/$service"
	fi

	if [ "$action" = "exists" ]; then 
		[ -n "$service_script" ] && return 0 || return 1
	elif [ -z "$service_script" ]; then
		warn "Unable to ${inten} - control script doesn't exist or isn't executable"
		return 1
	fi


	if [ -x "/usr/sbin/invoke-rc.d" ]; then
		action_cmd="/usr/sbin/invoke-rc.d $service"
	elif [ -x "/sbin/service" ]; then
		action_cmd="/sbin/service $service"
	elif [ -n ${service_script} ]; then
		action_cmd="$service_script"
	fi

	
	case "$action" in
		start)
			pleskrc $service_name status || $action_cmd $action
			;;
		stop)
			! pleskrc $service_name status || $action_cmd $action
			;;
		restart)
			if pleskrc $service_name status; then 
				$action_cmd $action
			else 
				$action_cmd start
			fi
			;;
		reload)
			! pleskrc $service_name status || $action_cmd $action
			;;
		status)
		    $action_cmd "status"
			;;
	    *)
		    $action_cmd $action
			;;
	esac >> $product_log 2>&1
}

is_function()
{
	local type_output="`type \"$1\" 2>/dev/null | head -n1 | awk '{print $NF}'`"
	test "X${type_output}" = "Xfunction"
}

# echo message to product log, unless debug
p_echo()
{
    if [ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" -o -z "$product_log" ] ; then
        echo "$@"
    else
        echo "$@" >> "$product_log" 2>&1
    fi
}

# echo message to product log without new line, unless debug
pnnl_echo()
{
    if [ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" -o -z "$product_log" ] ; then
        echo -n "$*"
    else
        echo -n "$*" >> "$product_log" 2>&1
    fi
}

die()
{
	PACKAGE_SCRIPT_FAILED="$*"

	printf "\a\a"
	report_problem \
		"ERROR while trying to $*" \
		"Check the error reason(see log file: ${product_log}), fix and try again"

	selinux_close

	exit 1
}

warn()
{
	local inten
	inten="$1"
	p_echo
	p_echo "WARNING!"
	pnnl_echo "Some problems are found during $inten"
	p_echo "(see log file: ${product_log})"
	p_echo
	p_echo "Continue..."
	p_echo

	product_log_tail | send_error_report_with_input "Warning: $inten"

	[ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" ] || \
	product_log_tail
}

# Use this function to report failed actions.
# Typical report should contain
# - reason or problem description (example: file copying failed)
# - how to resolve or investigate problem (example: check file permissions, free disk space)
# - how to re-run action (example: perform specific command, restart bootstrapper script, run installation again)
report_problem()
{
	[ -n "$product_problems_log" ] || product_problems_log="/dev/stderr"

	p_echo
	if [ "0$problems_occured" -eq 0 ]; then
		echo "***** $process problem report *****" >> "$product_problems_log" 2>&1
	fi
	for problem_message in "$@"; do
		p_echo "$problem_message"
		echo "$problem_message" >> "$product_problems_log" 2>&1
	done
	p_echo

	product_log_tail | send_error_report_with_input "Problem: $@"

	[ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" ] || \
		product_log_tail

	problems_occured=1
}

echo_try()
{
	msg="$*"
	pnnl_echo " Trying to $msg... "
}

suc()
{
	p_echo "done"
}

# do not call it w/o input! Use send_error_report in these cases.
send_error_report_with_input()
{
	{
		echo $@
		echo ""
		if [ -n "$error_report_context" ]; then
			echo "Context: $error_report_context"
			echo ""
		fi
		cat -
	} | $PRODUCT_ROOT_D/admin/bin/send-error-report "install" >/dev/null 2>&1
}

detect_vz()
{
	PLESK_VZ=0
	PLESK_VE_HW_NODE=0
	PLESK_VZ_TYPE=

	local issue_file="/etc/issue"
	local vzcheck_file="/proc/self/status"
	[ -f "$vzcheck_file" ] || return 1

	local env_id=`sed -ne 's|^envID\:[[:space:]]*\([[:digit:]]\+\)$|\1|p' "$vzcheck_file"`
	[ -n "$env_id" ] || return 1
	if [ "$env_id" = "0" ]; then
		# Either VZ/OpenVZ HW node or unjailed CloudLinux
		PLESK_VE_HW_NODE=1
		return 1
	fi

	if grep -q "CloudLinux" "$issue_file" >/dev/null 2>&1 ; then
		return 1
	fi

	if [ -f "/proc/vz/veredir" ]; then
		PLESK_VZ_TYPE="vz"
	elif [ -d "/proc/vz" ]; then
		PLESK_VZ_TYPE="openvz"
	fi

	PLESK_VZ=1
	return 0
}

product_log_tail()
{
	[ -f "$product_log" ] || return 0
	tac "$product_log" | awk '/^START/ { exit } { print }' | tac
}

read_conf()
{
	[ -n "$prod_conf_t" ] || prod_conf_t=/etc/psa/psa.conf

	if [ -s $prod_conf_t ]; then
		tmp_var=`perl -e 'undef $/; $_=<>; s/#.*$//gm;
				s/^\s*(\S+)\s*/$1=/mg;
				print' $prod_conf_t`
		eval $tmp_var
	else
		if [ "X$do_upgrade" = "X1" ]; then
			[ 0$ignore_miss_conf -ne 1 ] && p_echo "Unable to find product configuration file: $prod_conf_t"
			return 1
		fi
	fi
	return 0
}

selinux_close()
{
	if [ -z "$SELINUX_ENFORCE" -o "$SELINUX_ENFORCE" = "Disabled" ]; then
		return
	fi

	setenforce "$SELINUX_ENFORCE"
}
### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.

#set_params

set_common_params()
{
	common_var=0

	PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
	LANG=C
	export PATH LANG
	umask 022
	ulimit -n 65535 2>/dev/null

	K_HUP="/bin/kill -HUP"
	K_KILL="/bin/kill -KILL"
	K_TERM="/bin/kill -TERM"
	K_USR2="/bin/kill -USR2"
	K_TEST="/bin/kill -0"

	users_created=""
	groups_created=""

	certificate_file="$PRODUCT_ETC_D/httpsd.pem"
	services="/etc/services"
	mtab="/etc/mtab"
	get_hostname="hostname"
	get_domainname="domainname"

	#VZP used to determine that we're inside SVE
	vza_file="/var/vzagent"

	#default parameters
	tar="tar"
	crontab="/usr/bin/crontab"

	cp_preserve="cp -p"
	SYSTEM_RC_D=/etc/init.d
	PLESK_LIBEXEC_DIR="/usr/lib64/plesk-9.0"
	PLESK_DB_DIR="/var/lib/plesk"
	POSTFIX_LIBEXEC_DIR="/usr/libexec/postfix"
	PRODUCT_BOOTSTRAPPER_DIR="/usr/local/psa/bootstrapper/pp11.5.30-bootstrapper"
	AUTOGENERATED_CONFIGS="#ATTENTION!\n#\n#DO NOT MODIFY THIS FILE BECAUSE IT WAS GENERATED AUTOMATICALLY,\n#SO ALL YOUR CHANGES WILL BE LOST THE NEXT TIME THE FILE IS GENERATED.\n"
	AUTOGENERATED_CONFIGS_UPGRADE="#ATTENTION!\n#\n#DO NOT MODIFY THIS FILE BECAUSE IT WAS GENERATED AUTOMATICALLY,\n#SO ALL YOUR CHANGES WILL BE LOST AFTER YOU UPGRADE PARALLELS PLESK PANEL.\n"

	set_common_params_linux 

	detect_vz
}

set_common_params_linux()
{
	get_hostname="hostname -f"
	fstab="/etc/fstab"
	cp_preserve="cp --preserve=all --remove-destination"
	machine="linux"
	sendmail="/usr/sbin/sendmail"
	ps="ps axw"
	ps_long="ps axuw"
	false_shell="/bin/false"
	dummy_home="/"
	compress="gzip -9 -c"
	uncompress="gunzip -c"
	uudecode="uudecode -o /dev/stdout"
	ifconfig="/sbin/ifconfig -a"
	inet_str="inet addr"

	if [ -f /etc/slackware-version ]; then
	    linux_distr="slackware"
	    useradd_options=""
	    sndml_ini="/etc/rc.d/init.d/sendmail"
	    mail_local="/usr/libexec/mail.local"
	    dummy_shell=""
	    named_osrelease=0
	else
	    useradd_options="-M"
	    if [ -f /etc/mandrake-release ]; then
		linux_distr="mandrake"
	    elif [ -f /etc/fedora-release ]; then
		linux_distr="fedora"
	    elif [ -f /etc/SuSE-release ]; then
		linux_distr="suse"
		useradd_options="-r"
	    elif [ -f /etc/debian_version ]; then
		linux_distr="debian"
		get_domainname="dnsdomainname"
		useradd_options=""
	    else
		linux_distr="redhat"
	    fi

	    sndml_ini="/etc/init.d/sendmail"
	    mail_local="/usr/libexec/mail.local"
	    if [ -x /sbin/nologin ]; then
		dummy_shell="/sbin/nologin"
	    else
		dummy_shell="/bin/false"
	    fi
	    bash_shell="/bin/bash"
	    rbash_shell="/bin/rbash"
	    uudecode_full="/usr/bin/uudecode"
	    named_osrelease=`cat /proc/sys/kernel/osrelease | perl -F"/[.-]/" -n -a  -e 'printf "%02u%02u%02u\n", $F[0],$F[1],$F[2]'`
	fi

	return 0
}

### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
# vim:syntax=sh

set_nginx_params()
{
	nginx_service=nginx
	nginx_rc_config="/etc/sysconfig/nginx"
	nginx_user="nginx"
}

nginx_is_rc_enabled()
{
	grep -q '^\s*NGINX_ENABLED=\s*"\?yes"\?\s*\(#.*\)\?$' "$nginx_rc_config" >/dev/null 2>&1
}
### Copyright 1999-2012. Parallels IP Holdings GmbH. All Rights Reserved.
usage() {
cat << EOT
Usage: httpd_modules_ctl [OPTIONS]...

	-s, --status
	-e, --enable <module1,module2...>
	-d, --disable <module1,module2...>
	-h, --help  Display this help and exit
EOT
	return 1
}

enable_mod(){
	local modules
	local ret
	local IFS
	local module_soname
	local module_config
	modules=$1
	ret=0
	IFS=,
	for module in $modules ; do
		module_soname=""
		module_config=""
		if expr match "$module" 'php.*' 2>&1 > /dev/null; then
			module_soname="lib$module.so"
			module_config="$HTTPD_INCLUDE_D/php.conf"
		fi
		additional_apache_modules_d=""
		if ! add_apache_module "$module" "$module_soname" "$module_config" ; then
			ret=1
		fi
	done
	return $ret
}

disable_mod(){
	local modules
	local ret
	local IFS
	local module_soname
	local module_config
	modules=$1
	ret=0
	IFS=,
	for module in $modules ; do
		module_soname=""
		module_config=""
		if expr match "$module" 'php.*' 2>&1 > /dev/null; then
			module_soname="lib$module.so"
			module_config="$HTTPD_INCLUDE_D/php.conf"
		fi
		if ! remove_apache_module "$module" "$module_soname" "$module_config"  2>> $product_log ; then
			ret=1
		fi
	done
	return $ret
}

status_mods(){
	local all_mod_list
	local ena_mod_list
	local short_mod_name
	local required_mods
	local required_mods_re
	
	all_mod_list=`all_modules_list`
	required_mods=`required_modules_list`
	if [ -n "$required_mods" ] ; then
		required_mods_re="`echo "$required_mods" | tr '\n' ' ' | sed -s 's/\s\+/\\\|/g'`\$"
	fi

	ena_mod_list=`enabled_modules_list`
	ena_mod_list_err=$?
	if  [ "$ena_mod_list_err" != "0" ] ; then
		echo $ena_mod_list >> $product_log
		return $ena_mod_list_err
	fi

	for mod in $all_mod_list; do
		short_mod_name=""
		short_mod_name=`expr match "$mod" 'mod_\(.*\)$'`
		if [ "$?" != "0"  ] ; then
			short_mod_name=`expr match "$mod" 'lib\(.*\)$'`
			if [ "$?" != "0" ] ; then continue; fi
		fi
		# use filter for required modules
		if [ -z "$required_mods_re" ] || ! expr match "$short_mod_name" "$required_mods_re" 2>&1 > /dev/null ; then
			if echo $ena_mod_list | egrep -q "([[:space:]]+|^)${short_mod_name}(_module|)([[:space:]]|$)" ; then
				echo "$short_mod_name on"
			else
				echo "$short_mod_name off"
			fi
		fi
	done
	return 0
}

required_modules_list()
{
	echo "env auth_digest authn_file authz_host authz_user actions alias autoindex dav dir log_config mime negotiation setenvif ssl"

	set_nginx_params
	nginx_is_rc_enabled && echo "rpaf aclr"
}

all_modules_list()
{
	ls "$apache_modules_d" | cut -d '.' -f 1
	if [ -n "" ]; then
		find  -type f | xargs -n 1  basename  | cut -d '.' -f 1
	fi
}

enabled_modules_list()
{
	local ena_mod_list
	local apachectl_err
	if [ "$linux_distr" = "redhat" -o "$linux_distr" = "debian" -o "$linux_distr" = "ubuntu" ]; then
		# Note: this is actually required only for RedHat systems and old Debian-based (Debian 5, Ubuntu 8.04)
		ena_mod_list=`/usr/sbin/apachectl -M 2>&1`
		apachectl_err=$?
	else
		ena_mod_list=`/usr/sbin/apachectl -M 2>> $product_log`
		apachectl_err=$?
	fi

	if  [ "$apachectl_err" = "0" ] ; then
		echo "$ena_mod_list" | awk '$1 ~ /module/ {print $1}'
		return 0
	fi
	case "$linux_distr" in
		debian)
			ena_mod_list=`ls /etc/apache2/mods-enabled/*.load | xargs -n 1 basename | cut -d . -f 1 2>> $product_log`
			ena_mod_list_ret=$?
			if [ "$ena_mod_list_ret" != "0" ] ; then
				echo ena_mod_list_ret >> $product_log
				return 1
			fi
			echo $ena_mod_list
			return 0
		;;
		suse*)
			(. /etc/sysconfig/apache2;echo ${APACHE_MODULES}) 2>/dev/null;
			return 0;
		;;
		redhat*)
			grep -h LoadModule /etc/httpd/conf/* /etc/httpd/conf.d/*  | perl -n -e '$_ =~ s/^\s+//;$_ =~ s/\s+$//;next if($_ =~ m/^\s*#/);@f=split(); print substr($f[1], 0, -7); print "\n";'
			return $?
		;;
	esac

	return 1
}

## begin script

if [ $# -eq 0 ] ; then
    usage
    exit 1
fi

product_log=`mktemp /tmp/httpd_modules_ctl.XXXXXX`
read_conf
set_common_params
set_apache_params

TEMP=`getopt -o e:d:sh --long enable:,disable:,status,help -n "$0" -- "$@"`
if [ $? != 0 ] ; then 
	echo "Terminating..." >&2 
	rm -f $product_log 
	exit 1 
fi
eval set -- "$TEMP"

ret=0
to_restart=0
while true ; do
	case "$1" in
		-e|--enable)
			enable_mod $2
			ret=`expr $ret \| $?`
			to_restart=1
			shift 2
		;;
		-d|--disable)
			disable_mod $2
			ret=`expr $ret \| $?`
			to_restart=1
			shift 2
		;;
		-s|--status) 
			status_mods
			ret="$?"
			break
		;;
		-h|--help) 
			usage
			rm -f $product_log
			exit $?
		;;
		--) shift ; break ;;
		*) p_echo "Internal error!" ; exit 1 ;;
	esac
done

if [ "$to_restart" != "0" ] ; then
	# Restart web server
	if ! pleskrc apache restart  >> /dev/null 2>&1 ; then
		ret=1
	fi
fi

if [ "$ret" != "0" ]; then
	# Operation completed with errors. Cat $product_log on stdout
	cat $product_log
else
	p_echo "Operation completed successfully"
	rm -f $product_log
fi

exit $ret

# vim:syntax=sh
